// Importing necessary libraries for drawing the world map.
import { select, json, geoPath, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

//Creating a svg.
const svg = select('svg');

//Using the projection.
const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

//Defining the sphere around the world.
svg.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

//Read the .json file for the world map.
json('https://gist.githubusercontent.com/ubl2/4b6018f9d8def3ec56254ecee9de3212/raw/2dec73919c0a8337400dd22d55e889d40a02ea74/worldmap.json')
  .then(data => {
    const countries = feature(data, data.objects.countries);
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });